#include <dir.h>

#include <cwmm.h>
#include <cstdolw.h>
#include <cbutton.h>
#include <cmouse.h>
#include <cbgi.h>

void CLOSE_MENU     (CSTDOLW *p);
void BUTTON_MANAGER (CButton *p);
void BUTTON_EDITOR  (CButton *p);
void BUTTON_EXIT    (CButton *p);

CMouse *mouse = NULL;

void main()
{
mouse             = new CMouse;
CSTDOLW *win_menu = new CSTDOLW (CRect<int> (150, 150, 220, 220),
									"Car Integrator", CLOSE_MENU);
if (!mouse)    terminate ("Not enoug memeory\n");
if (!win_menu) terminate ("Not enoug memeory\n");

CWMM wmm (new CBGIScreen, mouse);

win_menu->add (new CButton (CRect<int> (50, 50, 100, 20), "Car Maneger",
													   BUTTON_MANAGER));
win_menu->add (new CButton (CRect<int> (50, 100, 100, 20), "Car Editor",
													   BUTTON_EDITOR ));
win_menu->add (new CButton (CRect<int> (50, 150, 100, 20), "Exit",
													   BUTTON_EXIT   ));
wmm.add (win_menu);
wmm.run ();
}


//----------------------CLOSE----------MENU-------------------------------\\
void CLOSE_MENU (CSTDOLW *p)
{
p->parent()->close();
}

//------------------------CALL----CARS-----------PROGRAM------------------\\
void BUTTON_MANAGER (CButton *p)
{
const char *tmp = searchpath ("cars.exe");
if (tmp)
	{
	((CWMM *) p->parent()->parent())->close();
	mouse->hide();
	system ("cars.exe");
	mouse->show();
	((CWMM *) p->parent()->parent())->draw();
	((CWMM *) p->parent()->parent())->run();
	}
}

//------------------------CALL----CAREDIT--------PROGRAM------------------\\
void BUTTON_EDITOR  (CButton *p)
{
const char *tmp = searchpath ("cars.exe");
if (tmp)
	{
	((CWMM *) p->parent()->parent())->close();
	mouse->hide();
	system ("editcar.exe");
	mouse->show();
	((CWMM *) p->parent()->parent())->draw();
	((CWMM *) p->parent()->parent())->run();
	}
}

//----------------------CLOSE----------MENU-------------------------------\\
void BUTTON_EXIT (CButton *p)
{
p->parent()->close();
}
