#ifndef _IN_H
#define _IN_H

#include <assert.h>
#include <math.h>

template <class T>
int In (T peremen, T min, T max)
{
assert (min <= max);
return min < peremen && peremen < max;
}

template <class T>
T Modul (T x)
{
return sqrt(x*x);
}

int Okrugl (long double p)
{
int k = 1;
if (p <= 0) k *= -1;
int pint = (int)p;
long double t = fabs(p - pint);
if (t >= 0.5) return pint + k;
else return pint;
}

#endif
