#ifndef _3D_H
#define _3D_H

#include <graphics.h>
#include <stdlib.h>
#include <conio.h>
#include <stdio.h>

void GrayBack ();
void ColorBar3D   (			   int x, int y, int shir, int high, int ramkaType  = 0, int color = LIGHTGRAY);
void Bar3D	   	  (			   int x, int y, int shir, int high, int ramkaType  = 0);
void Elipse3D  	  (			   int x, int y, int shir, int high, int elipseType = 0);
void Line3D    	  (			   int x, int y, int dlin, int lineType = 0);
void Frame3D 	  (			   int x, int y, int shir, int high, int ramkaType = 0);
void BarButton    (char* text, int x, int y, int shir, int high, int color, int status = 0);
void ElipseButton (char* text, int x, int y, int shir, int high, int color, int status = 0);
void LineButton	  (char* text, int x, int y, int dlin, int color, int status = 0, int textType = BOTTOM_TEXT);

void nmain()
{
int gDriver = DETECT, gMode = DETECT;
initgraph (&gDriver, &gMode, getenv ("BGI")); //Xmax = 639 Ymax = 479

/*cleardevice ();
GrayBack ();

BarButton    ("OK", 0,  -2, 200, 50, RED);
ElipseButton ("CANCEL", 0, -1, 200, 50, BROWN);
LineButton   ("CLOSE", 0, 0, 200, BLUE, 0, 0);
while (getch () != 13);
BarButton    ("OK", 0,  -2, 200, 50, RED, 100);
ElipseButton ("CANCEL", 0, -1, 200, 50, BROWN, 100);
LineButton   ("CLOSE", 0, 0, 200, BLUE, 100, 1);
while (getch () != 32);
BarButton    ("OK", 0,  -2, 200, 50, RED, 101);
ElipseButton ("CANCEL", 0, -1, 200, 50, BROWN, 101);
LineButton   ("CLOSE", 0, 0, 200, BLUE, 101, 2);
getch ();
BarButton    ("OK", 0,  -2, 200, 50, RED, 1);
ElipseButton ("CANCEL", 0, -1, 200, 50, BROWN, 1);
LineButton   ("CLOSE", 0, 0, 200, BLUE, 1, 1);
getch ();*/
/*
int mass [2700];
int maxx = getmaxx();
int maxy = getmaxy();
for (int x = 0, c = 0; x <= maxx; x+=2, c++)
	{
	if (c == 16)  c-= 16;
	setcolor (c);
	line (x, 0, x, maxy);
	}
getch();
GetField (mass, 100, 200, 130, 290);
PutField (mass, 100, 200, 130, 290);
getch ();*/
}


void GrayBack ()
{
setfillstyle (SOLID_FILL, LIGHTGRAY);
bar (0, 0, getmaxx(), getmaxy ());
}

void Bar3D (int x, int y, int shir, int high, int ramkaType)
{
int cvet1, cvet2;

if (x == ( 0)) x = (getmaxx() - shir)/2;
if (x == (-1)) x = 3;
if (x == (-2)) x = getmaxx () - shir - 3;
if (y == ( 0)) y = (getmaxy() - high)/2;
if (y == (-1)) y = 3;
if (y == (-2)) y = getmaxy () - high - 3;
if (ramkaType == 0) cvet1 = 15, cvet2 = 8;
if (ramkaType == 1) cvet1 = 8, cvet2 = 15;


int	x2 = x + shir,
	y2 = y + high;

setfillstyle (SOLID_FILL, LIGHTGRAY);
bar (x, y, x2, y2);
/*setcolor (BLACK);
rectangle (x-2, y-2, x2+2, y2+2);*/
setcolor (cvet1);
rectangle (x-1, y-1, x2+1, y2+1);
setcolor (cvet2);
line (x-1, y2+1, x2+1, y2+1);
line (x2+1, y2+1, x2+1, y-1
);

/*i = glub;
setcolor (BLACK);
line (x-i, y-i, x, y);
line (x2+i, y2+i, x2, y2);
line (x2+i, y-i, x2, y);
line (x-i, y2+i, x, y2);
*/
}

void Elipse3D (int x, int y, int shir, int high, int elipseType)
{
int deg;

if (x == ( 0)) x =  getmaxx()/2;
if (x == (-1)) x = shir/2 + 2;
if (x == (-2)) x = getmaxx () - shir/2 - 2;
if (y == ( 0)) y =  getmaxy()/2;
if (y == (-1)) y = high/2 + 2;
if (y == (-2)) y = getmaxy () - high/2 - 2;
if (elipseType == 1) deg = 0;
if (elipseType == 0) deg = 180;

setfillstyle (SOLID_FILL, LIGHTGRAY);
/*setcolor (BLACK);
fillellipse (x, y, shir/2+1, high/2+1);*/
setcolor (DARKGRAY);
ellipse (x, y, deg, deg + 180, shir/2, high/2);
setcolor (WHITE);
ellipse (x, y, deg + 180, deg + 360, shir/2, high/2);


}
void Line3D (int x, int y, int dlin, int lineType)
{
int cvet1, cvet2;
int shir = dlin;int vis = 0;int kx = 0;int ky = 1;

if (lineType >= 100)
	{
	shir = 0;
	vis = dlin;
	kx = 1;
	ky = 0;
	lineType -= 100;
	}

if (x == ( 0)) x = (getmaxx() - dlin)/2;
if (x == (-1)) x = 2;
if (x == (-2)) x = getmaxx () - dlin - 2;
if (y == ( 0)) y = getmaxy()/2;
if (y == (-1)) y = 2;
if (y == (-2)) y = getmaxy () - 3;
if (lineType == 0) cvet1 = 15, cvet2 = 8;
if (lineType == 1) cvet1 = 8, cvet2 = 15;

setcolor (cvet1); line (x,      y,      x + shir,      y + vis     );
setcolor (cvet2); line (x + kx, y + ky, x + kx + shir, y + ky + vis);
//setcolor (BLACK);
//rectangle (x-1, y-1, x+1+shir, y+2+high);
}

void BarButton (char* text, int x, int y, int shir, int high, int color, int status)
{
if (x == ( 0)) x = (getmaxx() - shir)/2;
if (x == (-1)) x = 3;
if (x == (-2)) x = getmaxx () - shir - 3;
if (y == ( 0)) y = (getmaxy() - high)/2;
if (y == (-1)) y = 3;
if (y == (-2)) y = getmaxy () - high - 3;

int midX = x + shir/2 - textwidth (text)/2,
	midY = y + high/2 -textheight (text)/2,
	glub = 0,
	color2 = color;

if (status > 99) color = DARKGRAY, glub = 1, color2 = WHITE, status -= 100;
if (status == 1) midX ++, midY ++;

Bar3D (x, y, shir, high, status);

setcolor (color2);
outtextxy (midX + glub, midY + glub, text);

setcolor (color);
outtextxy (midX, midY, text);

}



void ElipseButton (char* text, int x, int y, int shir, int high, int color, int status)
{
if (x == ( 0)) x =  getmaxx()/2;
if (x == (-1)) x = shir/2 + 2;
if (x == (-2)) x = getmaxx () - shir/2 - 2;
if (y == ( 0)) y =  getmaxy()/2;
if (y == (-1)) y = high/2 + 2;
if (y == (-2)) y = getmaxy () - high/2 - 2;

int midX = x - textwidth  (text)/2,
	midY = y - textheight (text)/2,
	glub = 0,
	color2 = color;

if (status > 99) color = DARKGRAY, glub = 1, color2 = WHITE, status -= 100;
if (status == 1) midX ++, midY ++;

Elipse3D (x, y, shir, high, status);

setcolor (color2);
outtextxy (midX + glub, midY + glub, text);

setcolor (color);
outtextxy (midX, midY, text);


}

void LineButton	  (char* text, int x, int y, int dlin, int color, int status, int textType)
{
int sdvig = 0;

if (x == ( 0)) x = (getmaxx() - dlin)/2;
if (x == (-1)) x = 2;
if (x == (-2)) x = getmaxx () - dlin - 2;
if (y == ( 0)) y = getmaxy()/2;
if (y == (-1)) y = 2;
if (y == (-2)) y = getmaxy () - 3;
if (textType == 0) sdvig -= textheight (text);
if (textType == 2) sdvig += textheight (text);

int midX = x + dlin/2 - textwidth (text)/2,
	midY = y - textheight (text)/2,
	glub = 0,
	color2 = color;

if (status > 99) color = DARKGRAY, glub = 1, color2 = WHITE, status -= 100;
if (status == 1) midX ++, midY ++;

Line3D (x, y, dlin, status);


setcolor (color2);
outtextxy (midX + glub, midY + glub + sdvig, text);

setcolor (color);
outtextxy (midX, midY + sdvig, text);
}

void Frame3D (int x, int y, int shir, int high, int ramkaType)
{
int cvet1, cvet2;

if (x == ( 0)) x = (getmaxx() - shir)/2;
if (x == (-1)) x = 3;
if (x == (-2)) x = getmaxx () - shir - 2;
if (y == ( 0)) y = (getmaxy() - high)/2;
if (y == (-1)) y = 3;
if (y == (-2)) y = getmaxy () - high - 3;
if (ramkaType == 0) cvet1 = 15, cvet2 = 8;
if (ramkaType == 1) cvet1 = 8, cvet2 = 15;


int	x2 = x + shir,
	y2 = y + high;

setcolor (cvet2);
rectangle (x-1, y-1, x2+2, y2+2);
setcolor (cvet1);
rectangle (x-2, y-2, x2+1, y2+1);

}


void ColorBar3D (int x, int y, int shir, int high, int ramkaType, int color)
{

if (x == ( 0)) x = (getmaxx() - shir)/2;
if (x == (-1)) x = 3;
if (x == (-2)) x = getmaxx () - shir - 3;
if (y == ( 0)) y = (getmaxy() - high)/2;
if (y == (-1)) y = 3;
if (y == (-2)) y = getmaxy () - high - 3;

int	x2 = x + shir,
	y2 = y + high;


Bar3D (x, y, shir, high, ramkaType);
setfillstyle (SOLID_FILL, color);
if (color == -1) setfillstyle (SOLID_FILL, LIGHTGRAY);
bar (x, y, x2, y2);
if (color == -1)
	{
	setcolor (RED);
	circle (x+shir/2, y + high/2, (shir > high) ? high/2-2 : shir/2 - 2);
	}

}

#endif