#ifndef _GRAPH_H
#define _GRAPH_H

#include <dos.h>
#include <string.h>
#include <E:\reserv\prog\h\3d.h>

int GetDot    (int x, int y);
int PutDot    (int x, int y, int color);
void GetField (int *mass, int x1, int y1, int x2, int y2);
void PutField (int *mass, int x1, int y1, int x2, int y2);
void Bar          (int x, int y, int shir, int vis);
void ColorBar     (int x1, int y1, int x2, int y2, int color);

void graphmain ()
{
int gDriver = DETECT, gMode = DETECT;
initgraph (&gDriver, &gMode,getenv("E:\reserv\prog\BGI")); //Xmax = 639 Ymax = 479

cleardevice ();
GrayBack ();

int mass [10001];

BarButton    ("OK", 0,  -2, 200, 50, RED, 1);
ElipseButton ("CANCEL", 0, -1, 200, 50, BROWN, 1);
LineButton   ("CLOSE", 0, 0, 200, BLUE, 1, 1);
GetField (mass, 150, 20, 249, 119);
getch ();
cleardevice();
PutField (mass, 150, 20, 249, 119);

getch();
}


int GetDot (int x, int y)
{
_AH = 0x0d;
_BH =    0;
_CX = (unsigned short) x;
_DX = (unsigned short) y;
__int__ (0x10);
return _AL;
}


int PutDot (int x, int y, int color)
{
_AH = 0x0c;
_BH =    0;
_CX = (unsigned short) x;
_DX = (unsigned short) y;
_AL = (unsigned  char) color;
__int__ (0x10);
return 0;
}
                 

void GetField (int *mass, int x1, int y1, int x2, int y2)
{
int w = x2-x1, h = y2-y1;
for (int y = 0; y <= h; y++)
	for (int x = 0; x <= w; x++)
		mass [y * w + x] = GetDot (x1 + x, y1 + y);
}

void PutField (int *mass, int x1, int y1, int x2, int y2)
{
int w = x2-x1, h = y2-y1;
for (int y = 0; y <= h; y++)
	for (int x = 0; x <= w; x++)
		PutDot (x1 + x, y1 + y, mass [y * w + x]);
}




void Bar (int x, int y, int shir, int vis)
{
for (int s = 0; s <= shir; s++)
	line (x+s, y, x+s, y + vis);
}

void ColorBar (int x1, int y1, int x2, int y2, int color)
{
int shir  = x2 - x1;
int high  = y2 - y1;
setfillstyle (SOLID_FILL, color);
if (color == -1) setfillstyle (SOLID_FILL, LIGHTGRAY);
bar (x1, y1, x2, y2);
if (color == -1)
	{
	setcolor (RED);
	circle (x1+shir/2, y1 + high/2, (shir > high) ? high/2-3 : shir/2 - 3);
	}
}

#endif