#ifndef _CLOSEBUT_H_
#define _CLOSEBUT_H_

#include <cbutton.h>
//---------------------------------------------------------------------------
class CCloseButton: public CButton
{
private:			virtual void getFocus();
					virtual void lostFocus();
public:
					CCloseButton (CRect<int> aLoc,
						void (*aMsClickP)(CButton *b) = NULL);
					virtual ~CCloseButton();

					virtual void draw();
};
//---------------------------------------------------------------------------
CCloseButton::CCloseButton (CRect<int> aLoc, void (*aMsClickP)(CButton *b)):
	CButton (aLoc, "", aMsClickP)
{
myEnableFocus = FALSE;
}

CCloseButton::~CCloseButton()
{
}

void CCloseButton::getFocus()
{
//parent()->nextFocus();
}

void CCloseButton::lostFocus()
{
}

void CCloseButton::draw()
{
if (!myDc) return;
myMouse->hide();
viewport();
myDc->rect3d (myLoc, myStatus);
if (myStatus != HIDE)
	{
	myDc->textstyle (DEFAULT_FONT, 1);
	myDc->text (CPoint<int> (myLoc.x() + 1, myLoc.y() + 1), "x", BLACK);
	}
myMouse->show();
}
//---------------------------------------------------------------------------
#endif